	;
	; Music driver.
	;
	org $1001-2
	dw $1001

time		= $0C88	
regs		= $0D50
volume_info	= $0E82
dest	= $F2
	
	dw $100B,0
	db $9E,"4109",0,0,0
	
Print16	macro addr
	lda #"$"
	jsr $FFD2
	lda #addr >> 8
	jsr $FB10
	lda #addr & 255
	jsr $FB10
	endm
	 
;	ldx Channel1
;	ldx Channel1_end
;	ldy Channel2
;	ldy Channel2_end
;	nop
;	;
;	lda #Channel1 >> 8
;	cmp #Channel1_end >> 8
;	bne b1
;	lda #Channel2 >> 8
;	cmp #Channel2_end >> 8
;	beq begin
;	;
;b1	inc $FF19
;	jmp *-3
 
begin	jsr $FF4F
	db $93
	db $22,"ICICLE WORKS XMAS",$22,$0D
	db "COMPOSED BY CSABO/LOD 2018",$0D,$0D
	db $9A,"ELAPSED TIME  :",$90," 00:00 ( )",$0D
	db $9A,"MAXIMUM RASTER:",$90," 00    ( )",$0D
	db $0D
	db $9A,"MUSIC         :",$90," "
	;
	db 0                          
	;       
	Print16 music_beg
	jsr $FF4F
	db " - ",0
	Print16 music_end
	;	
	jsr $FF4F
	db $0D,$0D
	db "FREQ 1        : ",$0D
	db "FREQ 2        : ",$0D
	db "VOLUME        : ",$0D
	db "NOISE         : "
	db 0
	
start	sei
	sta $FF3F
	;
	lda #$41
	sta $FF19
	lda #$51
	sta $FF15
	;
	;ldx #Channel1 & 255
	;ldy #Channel1 >> 8
	;jsr set_ch1
	;
	;ldx #Channel2 & 255
	;ldy #Channel2 >> 8
	;jsr set_ch2
	;
	jsr music_beg+$0
	;
main	lda #$2E
	cmp $FF1D
	bne *-3
	;
	dec $FF19
	jsr music_beg+$3
	inc $FF19
	;
	jsr inc_timer
	jsr dump_volume
	jsr dump_registers
	;
;	lda #$6B
;	cmp $FF1D
;	bne *-3
;	;
;	dec $FF19
;	jsr music_beg+$6
;	inc $FF19
	;
	;jsr dump_volume
	;
	lda #$CD
	cmp $FF1D
	bne *-3
	;
	dec $FF19
	jsr music_beg+$3
	inc $FF19
	;
	jsr dump_volume
	jsr dump_registers
	;
x3	jmp main
	;
inc_timer
	lda time+7
	clc
	adc #$01
	cmp #50
	bne inc1
	;
	ldx #$05
inc2	dex 
	cpx #$02
	beq inc2
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$30
inc3	sta time,x
	cmp #$30
	beq inc2
	;
	lda #$00
inc1	sta time+7
	;
	rts
time_end
	db $3A,$3A,$3A,$36,$3A
hex_char
	db "0123456789",1,2,3,4,5,6
	;
dump_volume
	ldx #$00
dv1	lda volume_info+0*40+1,x
	sta volume_info+0*40+0,x
	lda volume_info+1*40+1,x
	sta volume_info+1*40+0,x
	lda volume_info+2*40+1,x
	sta volume_info+2*40+0,x
	lda volume_info+3*40+1,x
	sta volume_info+3*40+0,x
	lda volume_info+4*40+1,x
	sta volume_info+4*40+0,x
	lda volume_info+5*40+1,x
	sta volume_info+5*40+0,x
	lda volume_info+6*40+1,x
	sta volume_info+6*40+0,x
	lda volume_info+7*40+1,x
	sta volume_info+7*40+0,x
	lda volume_info+8*40+1,x
	sta volume_info+8*40+0,x
	inx
	cpx #$25
	bne dv1
	;
	lda #volume_info+$25 & 255
	sta vol_ptr+1
	lda #volume_info+$25 >> 8
	sta vol_ptr+2
	;
	ldx #$08
dv4	ldy #$2D
	stx dv2+1
	lda $FF11
	and #$0F
dv2	cmp #$00
	bne dv3
	ldy #$51
dv3	tya
vol_ptr	sta $1000
	;
	lda vol_ptr+1
	clc
	adc #40
	sta vol_ptr+1
	lda vol_ptr+2
	adc #00
	sta vol_ptr+2
	;
	dex
	bpl dv4
	rts

dump_registers
	lda #(regs + 0*40 & 255)
	sta dest
	lda #(regs + 0*40 >> 8)
	sta dest+1
	;
	ldx $FF0E
	lda $FF12
	and #$03
	jsr write_word
	;
	lda #(regs + 1*40 & 255)
	sta dest
	lda #(regs + 1*40 >> 8)
	sta dest+1
	;
	ldx $FF0F
	lda $FF10
	and #$03
	jsr write_word
	;
	lda #(regs + 2*40 & 255)
	sta dest
	lda #(regs + 2*40 >> 8)
	sta dest+1
	;
	lda $FF11
	and #$0F
	jsr write_byte
	;
	lda #(regs + 3*40 & 255)
	sta dest
	lda #(regs + 3*40 >> 8)
	sta dest+1
	;
	lda $FF11
	and #$40
	jsr write_byte
	;
	rts
	
	;
	; A,X = hex value to print (hi,lo)
	;
write_word
	stx x_sav2+1
	jsr write_byte
x_sav2	lda #$00
	;
	; A = hex value to print
	;
write_byte
	sty y_save+1
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	ldy #$00
	sta (dest),y
	pla
	and #$0F
	tax
	lda hex_char,x
	iny
	sta (dest),y
	;
	lda #$02
	jsr add_dest
y_save	ldy #$00
	rts

add_dest_1
	lda #$01
add_dest
	clc
	adc dest
	sta dest
	bcc *+4
	inc dest+1
	rts
	;
	align 256
music_beg
	include "!player.asm"
	;align 256
	include "music.asm"
music_end
;